/**
 * Copyright (c) 2004-2015, Istvan David, Istvan Rath and Daniel Varro
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *   Istvan David - initial API and implementation
 */
package org.eclipse.viatra.cep.core.metamodels.trace;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each operation of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see org.eclipse.viatra.cep.core.metamodels.trace.TraceFactory
 * @model kind="package"
 * @generated
 */
public interface TracePackage extends EPackage {
	/**
	 * The package name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNAME = "trace";

	/**
	 * The package namespace URI.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_URI = "trace.meta";

	/**
	 * The package namespace name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_PREFIX = "org.eclipse.viatra.cep.core.metamodels";

	/**
	 * The singleton instance of the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	TracePackage eINSTANCE = org.eclipse.viatra.cep.core.metamodels.trace.impl.TracePackageImpl.init();

	/**
	 * The meta object id for the '{@link org.eclipse.viatra.cep.core.metamodels.trace.impl.TraceModelImpl <em>Model</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.viatra.cep.core.metamodels.trace.impl.TraceModelImpl
	 * @see org.eclipse.viatra.cep.core.metamodels.trace.impl.TracePackageImpl#getTraceModel()
	 * @generated
	 */
	int TRACE_MODEL = 0;

	/**
	 * The feature id for the '<em><b>Traces</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRACE_MODEL__TRACES = 0;

	/**
	 * The feature id for the '<em><b>Timed Zone Traces</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRACE_MODEL__TIMED_ZONE_TRACES = 1;

	/**
	 * The number of structural features of the '<em>Model</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRACE_MODEL_FEATURE_COUNT = 2;

	/**
	 * The number of operations of the '<em>Model</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRACE_MODEL_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link org.eclipse.viatra.cep.core.metamodels.trace.impl.TraceImpl <em>Trace</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.viatra.cep.core.metamodels.trace.impl.TraceImpl
	 * @see org.eclipse.viatra.cep.core.metamodels.trace.impl.TracePackageImpl#getTrace()
	 * @generated
	 */
	int TRACE = 1;

	/**
	 * The feature id for the '<em><b>Event Pattern</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRACE__EVENT_PATTERN = 0;

	/**
	 * The feature id for the '<em><b>Automaton</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRACE__AUTOMATON = 1;

	/**
	 * The number of structural features of the '<em>Trace</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRACE_FEATURE_COUNT = 2;

	/**
	 * The number of operations of the '<em>Trace</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRACE_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link org.eclipse.viatra.cep.core.metamodels.trace.impl.TimedZoneTraceImpl <em>Timed Zone Trace</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.viatra.cep.core.metamodels.trace.impl.TimedZoneTraceImpl
	 * @see org.eclipse.viatra.cep.core.metamodels.trace.impl.TracePackageImpl#getTimedZoneTrace()
	 * @generated
	 */
	int TIMED_ZONE_TRACE = 2;

	/**
	 * The feature id for the '<em><b>Timed Zone</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIMED_ZONE_TRACE__TIMED_ZONE = 0;

	/**
	 * The feature id for the '<em><b>Transition</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIMED_ZONE_TRACE__TRANSITION = 1;

	/**
	 * The number of structural features of the '<em>Timed Zone Trace</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIMED_ZONE_TRACE_FEATURE_COUNT = 2;

	/**
	 * The number of operations of the '<em>Timed Zone Trace</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIMED_ZONE_TRACE_OPERATION_COUNT = 0;


	/**
	 * Returns the meta object for class '{@link org.eclipse.viatra.cep.core.metamodels.trace.TraceModel <em>Model</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Model</em>'.
	 * @see org.eclipse.viatra.cep.core.metamodels.trace.TraceModel
	 * @generated
	 */
	EClass getTraceModel();

	/**
	 * Returns the meta object for the containment reference list '{@link org.eclipse.viatra.cep.core.metamodels.trace.TraceModel#getTraces <em>Traces</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Traces</em>'.
	 * @see org.eclipse.viatra.cep.core.metamodels.trace.TraceModel#getTraces()
	 * @see #getTraceModel()
	 * @generated
	 */
	EReference getTraceModel_Traces();

	/**
	 * Returns the meta object for the reference list '{@link org.eclipse.viatra.cep.core.metamodels.trace.TraceModel#getTimedZoneTraces <em>Timed Zone Traces</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Timed Zone Traces</em>'.
	 * @see org.eclipse.viatra.cep.core.metamodels.trace.TraceModel#getTimedZoneTraces()
	 * @see #getTraceModel()
	 * @generated
	 */
	EReference getTraceModel_TimedZoneTraces();

	/**
	 * Returns the meta object for class '{@link org.eclipse.viatra.cep.core.metamodels.trace.Trace <em>Trace</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Trace</em>'.
	 * @see org.eclipse.viatra.cep.core.metamodels.trace.Trace
	 * @generated
	 */
	EClass getTrace();

	/**
	 * Returns the meta object for the reference '{@link org.eclipse.viatra.cep.core.metamodels.trace.Trace#getEventPattern <em>Event Pattern</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Event Pattern</em>'.
	 * @see org.eclipse.viatra.cep.core.metamodels.trace.Trace#getEventPattern()
	 * @see #getTrace()
	 * @generated
	 */
	EReference getTrace_EventPattern();

	/**
	 * Returns the meta object for the reference '{@link org.eclipse.viatra.cep.core.metamodels.trace.Trace#getAutomaton <em>Automaton</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Automaton</em>'.
	 * @see org.eclipse.viatra.cep.core.metamodels.trace.Trace#getAutomaton()
	 * @see #getTrace()
	 * @generated
	 */
	EReference getTrace_Automaton();

	/**
	 * Returns the meta object for class '{@link org.eclipse.viatra.cep.core.metamodels.trace.TimedZoneTrace <em>Timed Zone Trace</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Timed Zone Trace</em>'.
	 * @see org.eclipse.viatra.cep.core.metamodels.trace.TimedZoneTrace
	 * @generated
	 */
	EClass getTimedZoneTrace();

	/**
	 * Returns the meta object for the reference '{@link org.eclipse.viatra.cep.core.metamodels.trace.TimedZoneTrace#getTimedZone <em>Timed Zone</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Timed Zone</em>'.
	 * @see org.eclipse.viatra.cep.core.metamodels.trace.TimedZoneTrace#getTimedZone()
	 * @see #getTimedZoneTrace()
	 * @generated
	 */
	EReference getTimedZoneTrace_TimedZone();

	/**
	 * Returns the meta object for the reference '{@link org.eclipse.viatra.cep.core.metamodels.trace.TimedZoneTrace#getTransition <em>Transition</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Transition</em>'.
	 * @see org.eclipse.viatra.cep.core.metamodels.trace.TimedZoneTrace#getTransition()
	 * @see #getTimedZoneTrace()
	 * @generated
	 */
	EReference getTimedZoneTrace_Transition();

	/**
	 * Returns the factory that creates the instances of the model.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the factory that creates the instances of the model.
	 * @generated
	 */
	TraceFactory getTraceFactory();

	/**
	 * <!-- begin-user-doc -->
	 * Defines literals for the meta objects that represent
	 * <ul>
	 *   <li>each class,</li>
	 *   <li>each feature of each class,</li>
	 *   <li>each operation of each class,</li>
	 *   <li>each enum,</li>
	 *   <li>and each data type</li>
	 * </ul>
	 * <!-- end-user-doc -->
	 * @generated
	 */
	interface Literals {
		/**
		 * The meta object literal for the '{@link org.eclipse.viatra.cep.core.metamodels.trace.impl.TraceModelImpl <em>Model</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.eclipse.viatra.cep.core.metamodels.trace.impl.TraceModelImpl
		 * @see org.eclipse.viatra.cep.core.metamodels.trace.impl.TracePackageImpl#getTraceModel()
		 * @generated
		 */
		EClass TRACE_MODEL = eINSTANCE.getTraceModel();

		/**
		 * The meta object literal for the '<em><b>Traces</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference TRACE_MODEL__TRACES = eINSTANCE.getTraceModel_Traces();

		/**
		 * The meta object literal for the '<em><b>Timed Zone Traces</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference TRACE_MODEL__TIMED_ZONE_TRACES = eINSTANCE.getTraceModel_TimedZoneTraces();

		/**
		 * The meta object literal for the '{@link org.eclipse.viatra.cep.core.metamodels.trace.impl.TraceImpl <em>Trace</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.eclipse.viatra.cep.core.metamodels.trace.impl.TraceImpl
		 * @see org.eclipse.viatra.cep.core.metamodels.trace.impl.TracePackageImpl#getTrace()
		 * @generated
		 */
		EClass TRACE = eINSTANCE.getTrace();

		/**
		 * The meta object literal for the '<em><b>Event Pattern</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference TRACE__EVENT_PATTERN = eINSTANCE.getTrace_EventPattern();

		/**
		 * The meta object literal for the '<em><b>Automaton</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference TRACE__AUTOMATON = eINSTANCE.getTrace_Automaton();

		/**
		 * The meta object literal for the '{@link org.eclipse.viatra.cep.core.metamodels.trace.impl.TimedZoneTraceImpl <em>Timed Zone Trace</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.eclipse.viatra.cep.core.metamodels.trace.impl.TimedZoneTraceImpl
		 * @see org.eclipse.viatra.cep.core.metamodels.trace.impl.TracePackageImpl#getTimedZoneTrace()
		 * @generated
		 */
		EClass TIMED_ZONE_TRACE = eINSTANCE.getTimedZoneTrace();

		/**
		 * The meta object literal for the '<em><b>Timed Zone</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference TIMED_ZONE_TRACE__TIMED_ZONE = eINSTANCE.getTimedZoneTrace_TimedZone();

		/**
		 * The meta object literal for the '<em><b>Transition</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference TIMED_ZONE_TRACE__TRANSITION = eINSTANCE.getTimedZoneTrace_Transition();

	}

} //TracePackage
